clear
clc
% CAT ALL SUBJECTS
rets_seq = {};
rets_ir = {};
sjs = 24;
pth_ = pwd;

colors = [69 213 219; ...
        73 145 216;...
        170 227 63; ...
        247 236 119;...
        245 179 106;...
        204 85 159; ...
        254 126 189;...
        243 149 128;...
        191 210 134;...
        247 122 122;...
        156 187 212;...
        134 235 149; ...
        116 247 254;...
        225 101 123;...
        244 122 81; ...
        156 156 255;...
        182 111 253;...
        195 248 36;...
        222 141 141;...
        160 65 213;...
        185 15 15;...
        58 145 108;...
        254 127 254;...
        224 185 156]./255;

pos1 = [1 4 7 10];
pos2 = pos1+1;
pos3 = pos1+2;

%%
for sj = 1: sjs
    
    load([pth_(1:end-8) filesep 'subject' sprintf('%03d', sj) filesep 'LOGsubject' sprintf('%03d', sj) '.mat'])
    
    ret_seq =[];
    ret_ir = [];
    b = 1;
    while isfield(LOG, ['retrieval' num2str(b) '_seq']) || isfield(LOG, ['retrieval' num2str(b) '_ir'])
        if isfield(LOG, ['retrieval' num2str(b) '_seq']) && ~isfield(LOG, ['retrieval' num2str(b) '_ir'])
            eval(['ret_seq = cat(1, ret_seq, LOG.retrieval' num2str(b) '_seq);']);
        elseif  isfield(LOG, ['retrieval' num2str(b) '_ir']) && ~isfield(LOG, ['retrieval' num2str(b) '_seq']) 
            eval(['ret_ir = cat(1, ret_ir, LOG.retrieval' num2str(b) '_ir);']);
        end
        b = b+1;
    end
    
    %this is to remove subject information for publication!
    if isfield(LOG, 'info')
        LOG = rmfield(LOG, 'info');
        save([pth_ filesep 'subject' sprintf('%03d', sj) filesep 'LOGsubject' sprintf('%03d', sj) '.mat'], 'LOG')
    end
    
    rets_seq = cat(2,rets_seq,{ret_seq});
    rets_ir = cat(2,rets_ir,{ret_ir});
end

%% reaction times positions SEQ
pos = [pos1;pos2;pos3];
dist_check = cell(sjs,3);
rts_cleanpos = nan(sjs,3);
for s = 1 : sjs
    ret = squeeze(rets_seq{1,s});
    hit_trials = ret(cell2mat(ret(:,3))==cell2mat(ret(:,10))&cell2mat(ret(:,4))==cell2mat(ret(:,7)) & cell2mat(ret(:,13))>1, :);
    rt_all =  cell2mat(hit_trials(:,8));
    for c = 1 : 3
        
        ind_vec = (cell2mat(hit_trials(:,4)) == c);
        rt_ = rt_all(ind_vec);
        std_lim = mean(rt_) + 2.5*std(rt_);
        rt_ = rt_(0.2<rt_ & rt_<std_lim);
        rts_cleanpos(s,c)= mean(log(rt_),1);
        dist_check{s, c} = rt_;
    end
end

zrts_pos = (rts_cleanpos-repmat(mean(rts_cleanpos,2),[1 3]))./repmat(std(rts_cleanpos,0,2),[1 3]);

norm_pos_SEQ = (rts_cleanpos-repmat(mean(rts_cleanpos,2),[1 3]));

figure;
% colors = distinguishable_colors(sjs);

errorbar(mean(norm_pos_SEQ,1), std(norm_pos_SEQ,0,1),'-', 'Color', [0.71 0.71 0.71], 'LineWidth', 2);
hold on;
for s = 1 : sjs
    plot(norm_pos_SEQ(s,:), 'x',  'Color',colors(s,:), 'MarkerSize',9,'LineWidth', 2)
    hold on;
    xlim([0.5 3.5])
    ylim([-1 1]);
end
title('recall position');

set(gca, 'XTickLabel', {'',  'Pos1','', 'Pos2','', 'Pos3', ''})
set(gcf,'Color', 'white');
ylabel('difference to mean (ms)')
legend( ['mean', arrayfun(@(x) ['sj' num2str(x)],1:sjs,'UniformOutput',0)], 'Location', 'eastoutside'); legend('boxoff')

[h,p1, ci1, stats12] = ttest(rts_cleanpos(:,1),rts_cleanpos(:,2), 'Tail', 'left');
[h,p2, ci2, stats13] = ttest(rts_cleanpos(:,1),rts_cleanpos(:,3), 'Tail', 'left');
[h,p3, ci3, stats23] = ttest(rts_cleanpos(:,2),rts_cleanpos(:,3), 'Tail', 'left');

disp([p1 p2 p3])
disp(1000*[ci1 ci2 ci3])
%% reaction times positions IR
pos = [pos1;pos2;pos3];

rts_cleanpos_ir = nan(sjs,3);
for s = 1 : sjs
    ret = squeeze(rets_ir{1,s});
    hit_trials = ret(cell2mat(ret(:,7))==cell2mat(ret(:,10)) & cell2mat(ret(:,13))>1,:);
    rt_all =  cell2mat(hit_trials(:,8));
    for c = 1 : 3
        
        ind_vec = (cell2mat(hit_trials(:,4)) == c);
        rt_ = rt_all(ind_vec);
        std_lim = mean(rt_) + 2.5*std(rt_);
        rt_ = rt_(0.2<rt_ & rt_<std_lim);
        rts_cleanpos_ir(s,c)= mean(log(rt_),1);
    end
end

zrts_pos_IR = (rts_cleanpos_ir-repmat(mean(rts_cleanpos_ir,2),[1 3]))./repmat(std(rts_cleanpos_ir,0,2),[1 3]);

norm_pos_IR = (rts_cleanpos_ir-repmat(mean(rts_cleanpos_ir,2),[1 3]));


figure;
% colors = distinguishable_colors(sjs);

errorbar(mean(norm_pos_IR,1), std(norm_pos_IR,0,1),'-', 'Color', [0.71 0.71 0.71], 'LineWidth', 2);
hold on;
for s = 1 : sjs
    plot(norm_pos_IR(s,:), 'x',  'Color',colors(s,:), 'MarkerSize',9,'LineWidth', 2)
    hold on;
    xlim([0.5 3.5])
    ylim([-1 1]);
end
set(gca, 'XTickLabel', {'', 'Pos1','', 'Pos2','', 'Pos3', ''})
set(gcf,'Color', 'white');
ylabel('deifference to mean (ms)')
legend( ['mean', arrayfun(@(x) ['sj' num2str(x)],1:sjs,'UniformOutput',0)], 'Location', 'eastoutside'); legend('boxoff')
title('recognition association')



[h,p1, ci, stats12] = ttest(rts_cleanpos_ir(:,1),rts_cleanpos_ir(:,2));
[h,p2, ci, stats13] = ttest(rts_cleanpos_ir(:,1),rts_cleanpos_ir(:,3));
[h,p3, ci, stats23] = ttest(rts_cleanpos_ir(:,2),rts_cleanpos_ir(:,3));
p1
p2
p3


%% ANOVAS


[efs,F,cdfs,p,eps,dfs,b,y2,sig] = repanova([rts_cleanpos], [ 3], {'SEQposition'});

[efs,F,cdfs,p,eps,dfs,b,y2,sig] = repanova([rts_cleanpos_ir], [ 3], {'IRposition'});

[efs,F,cdfs,p,eps,dfs,b,y2,sig] = repanova([rts_cleanpos ,rts_cleanpos_ir], [2 3], {'condition' 'position'});

[h,pRTall, ci, stats] =  ttest(mean(rts_cleanpos_ir,2), mean(rts_cleanpos,2))

%%

