clear
clc
% CAT ALL SUBJECTS
rets_seq = {};
rets_ir = {};
sjs = 24;
pth_ = pwd;

colors = [69 213 219; ...
        73 145 216;...
        170 227 63; ...
        247 236 119;...
        245 179 106;...
        204 85 159; ...
        254 126 189;...
        243 149 128;...
        191 210 134;...
        247 122 122;...
        156 187 212;...
        134 235 149; ...
        116 247 254;...
        225 101 123;...
        244 122 81; ...
        156 156 255;...
        182 111 253;...
        195 248 36;...
        222 141 141;...
        160 65 213;...
        185 15 15;...
        58 145 108;...
        254 127 254;...
        224 185 156]./255;

pos1 = [1 4 7 10];
pos2 = pos1+1;
pos3 = pos1+2;

%%
for sj = 1: sjs
    
    load([pth_(1:end-8) filesep 'subject' sprintf('%03d', sj) filesep 'LOGsubject' sprintf('%03d', sj) '.mat'])
    
    ret_seq =[];
    ret_ir = [];
    b = 1;
    while isfield(LOG, ['retrieval' num2str(b) '_seq']) || isfield(LOG, ['retrieval' num2str(b) '_ir'])
        if isfield(LOG, ['retrieval' num2str(b) '_seq']) && ~isfield(LOG, ['retrieval' num2str(b) '_ir'])
            eval(['ret_seq = cat(1, ret_seq, LOG.retrieval' num2str(b) '_seq);']);
        elseif  isfield(LOG, ['retrieval' num2str(b) '_ir']) && ~isfield(LOG, ['retrieval' num2str(b) '_seq']) 
            eval(['ret_ir = cat(1, ret_ir, LOG.retrieval' num2str(b) '_ir);']);
        end
        b = b+1;
    end
    
    %this is to remove subject information for publication!
    if isfield(LOG, 'info')
        LOG = rmfield(LOG, 'info');
        save([pth_ filesep 'subject' sprintf('%03d', sj) filesep 'LOGsubject' sprintf('%03d', sj) '.mat'], 'LOG')
    end
    
    rets_seq = cat(2,rets_seq,{ret_seq});
    rets_ir = cat(2,rets_ir,{ret_ir});
end

%% reaction times positions CR (sequence = seq)
% addpath(genpath('C:\matlab_scripts\plotting'));
pos = [pos1;pos2;pos3];
dist_check = cell(sjs,3);
rts_cleanpos = nan(sjs,3);
for s = 1 : sjs
    ret = squeeze(rets_seq{1,s});
    % noGUESS
    hit_trials = ret(cell2mat(ret(:,3))==cell2mat(ret(:,10))&cell2mat(ret(:,4))==cell2mat(ret(:,7)) &...
        cell2mat(ret(:,13))>1, :);
    rt_all =  cell2mat(hit_trials(:,8));
    for c = 1 : 3
        
        ind_vec = (cell2mat(hit_trials(:,4)) == c);
        rt_ = rt_all(ind_vec);
        std_lim = mean(rt_) + 2.5*std(rt_);
        rt_ = rt_(0.2<rt_ & rt_<std_lim);
        rts_cleanpos(s,c)= mean(rt_,1);
        dist_check{s, c} = rt_;
    end
end

zrts_pos = (rts_cleanpos-repmat(mean(rts_cleanpos,2),[1 3]))./repmat(std(rts_cleanpos,0,2),[1 3]);

norm_pos_SEQ = (rts_cleanpos-repmat(mean(rts_cleanpos,2),[1 3]));

figure;
% colors = distinguishable_colors(sjs);

errorbar(mean(norm_pos_SEQ,1), std(norm_pos_SEQ,0,1),'-', 'Color', [0.71 0.71 0.71], 'LineWidth', 2);
hold on;
for s = 1 : sjs
    %plot(norm_pos_SEQ(s,:), 'x',  'Color',colors(s,:), 'MarkerSize',9,'LineWidth', 2) 
    plot(norm_pos_SEQ(s,:), 'x',  'MarkerSize',9,'LineWidth', 2)
   
    hold on;
    xlim([0.5 3.5])
    ylim([-1 1]);
end
title('recall position');

set(gca, 'XTickLabel', {'',  'Pos1','', 'Pos2','', 'Pos3', ''})
set(gcf,'Color', 'white');
ylabel('difference to mean (ms)')
legend( ['mean', arrayfun(@(x) ['sj' num2str(x)],1:sjs,'UniformOutput',0)], 'Location', 'eastoutside'); legend('boxoff')
% legend('mean', 'sj1', 'sj2', 'sj3', 'sj4', 'sj5', 'sj6','sj7', 'sj8', 'sj9', 'sj10', 'sj11','sj12', 'sj13','sj14', 'sj15', 'sj16', 'sj17', 'sj18', 'Location', 'eastoutside'); legend('boxoff')
% %% NOTE DO WE WANT TO DO A T-TEST OF ZSCORES INSTEAD?
[h,p1, ci1, stats12] = ttest(rts_cleanpos(:,1),rts_cleanpos(:,2), 'Tail', 'left');
[h,p2, ci2, stats13] = ttest(rts_cleanpos(:,1),rts_cleanpos(:,3), 'Tail', 'left');
[h,p3, ci3, stats23] = ttest(rts_cleanpos(:,2),rts_cleanpos(:,3), 'Tail', 'left');
p1;
p2;
p3;
ci_ = [ci1 ci2 ci3].*1000
cp_ = [p1 p2 p3]

%% reaction times positions AR (Intact Rearranged = IR)
pos = [pos1;pos2;pos3];

rts_cleanpos_ir = nan(sjs,3);
for s = 1 : sjs
    ret = squeeze(rets_ir{1,s});
    hit_trials = ret(cell2mat(ret(:,7))==cell2mat(ret(:,10)) & cell2mat(ret(:,13))>1,:);
    rt_all =  cell2mat(hit_trials(:,8));
    for c = 1 : 3
        
        ind_vec = (cell2mat(hit_trials(:,4)) == c);
        rt_ = rt_all(ind_vec);
        std_lim = mean(rt_) + 2.5*std(rt_);
        rt_ = rt_(0.2<rt_ & rt_<std_lim);
        rts_cleanpos_ir(s,c)= mean(rt_,1);
    end
end

zrts_pos_IR = (rts_cleanpos_ir-repmat(mean(rts_cleanpos_ir,2),[1 3]))./repmat(std(rts_cleanpos_ir,0,2),[1 3]);

norm_pos_IR = (rts_cleanpos_ir-repmat(mean(rts_cleanpos_ir,2),[1 3]));


figure;
% colors = distinguishable_colors(sjs);

errorbar(mean(norm_pos_IR,1), std(norm_pos_IR,0,1),'-', 'Color', [0.71 0.71 0.71], 'LineWidth', 2);
hold on;
for s = 1 : sjs
%     plot(norm_pos_IR(s,:), 'x',  'Color',colors(s,:), 'MarkerSize',9,'LineWidth', 2)
    plot(norm_pos_IR(s,:), 'x',  'MarkerSize',9,'LineWidth', 2)
   
    hold on;
    xlim([0.5 3.5])
    ylim([-1 1]);
end
set(gca, 'XTickLabel', {'', 'Pos1','', 'Pos2','', 'Pos3', ''})
set(gcf,'Color', 'white');
ylabel('deifference to mean (ms)')
legend( ['mean', arrayfun(@(x) ['sj' num2str(x)],1:sjs,'UniformOutput',0)], 'Location', 'eastoutside'); legend('boxoff')
title('recognition association')


% %%
% legend('mean', 'sj1', 'sj2', 'sj3', 'sj4', 'sj5', 'sj6','sj7', 'sj8', 'sj9', 'sj10', 'sj11','sj12', 'sj13','sj14', 'sj15', 'sj16', 'sj17', 'sj18', 'Location', 'eastoutside'); legend('boxoff')
% %% NOTE DO WE WANT TO DO A T-TEST OF ZSCORES INSTEAD?
[h,p1, ci, stats12] = ttest(rts_cleanpos_ir(:,1),rts_cleanpos_ir(:,2));
[h,p2, ci, stats13] = ttest(rts_cleanpos_ir(:,1),rts_cleanpos_ir(:,3));
[h,p3, ci, stats23] = ttest(rts_cleanpos_ir(:,2),rts_cleanpos_ir(:,3));
p1
p2
p3


%% rm ANOVAs


[efs,F,cdfs,p,eps,dfs,b,y2,sig] = repanova([rts_cleanpos], [ 3], {'SEQposition'});

[efs,F,cdfs,p,eps,dfs,b,y2,sig] = repanova([rts_cleanpos_ir], [ 3], {'IRposition'});

[efs,F,cdfs,p,eps,dfs,b,y2,sig] = repanova([rts_cleanpos ,rts_cleanpos_ir], [2 3], {'condition' 'position'});

% do: mse *df2 = sse and ss/(ss+sse) = partial eta square



[h,pRTall, ci, stats] =  ttest(mean(rts_cleanpos_ir,2), mean(rts_cleanpos,2));


%% REPLOT for figure
figure;
set(gcf, 'Position', get(0,'Screensize')); 
set(gcf, 'color', 'w');
subplot(2,2,[1 3]);


%colors = distinguishable_colors(sjs);
bp = boxplot(norm_pos_SEQ,'labels', {'', '', ''},'colors', [0 0 0], 'Widths',0.1);
set(bp,'linewidth',2);
h=findobj(gca,'tag','Outliers');
set(h,'Visible', 'off') 
hold on
% errorbar(mean(norm_pos_SEQ,1), std(norm_pos_SEQ,0,1)./sqrt(size(norm_pos_SEQ,1)),'-', 'Color', [0.71 0.71 0.71], 'LineWidth', 4);

jit_div = 10;
dist_ = 0.15;
tmpj = rand(24,3); tmpj =  bsxfun(@rdivide, bsxfun(@minus, tmpj,  mean(tmpj,1)), jit_div);
jitters = repmat([1 2 3], [sjs,1]) + tmpj;
for s = 1 : sjs
     plot(jitters(s,1:2)+dist_, norm_pos_SEQ(s,1:2), 'o',  'Color', (colors(s,:)),'MarkerFaceColor', (colors(s,:)), 'MarkerSize',4,'LineWidth', 2)
     plot(jitters(s,1:2)+(1-dist_), norm_pos_SEQ(s,2:3), 'o',  'Color', (colors(s,:)),'MarkerFaceColor', (colors(s,:)), 'MarkerSize',4,'LineWidth', 2)
    
     plot([(jitters(s,1)+dist_) (jitters(s,1)+(1-dist_))], norm_pos_SEQ(s,1:2), '-','Color', (colors(s,:)), 'LineWidth', 1)
    plot([(jitters(s,2)+dist_) (jitters(s,2)+(1-dist_))], norm_pos_SEQ(s,2:3), '-','Color', (colors(s,:)), 'LineWidth', 1)
 
     hold on;
    xlim([0.5 3.5]);
    ylim([-0.9 0.9]);
end
plot(mean(norm_pos_SEQ,1), 'o','Color', [1 0 0], 'MarkerSize',8, 'MarkerFaceColor', [1 0 0])

subplot(2,2,[2 4]);
% colors = distinguishable_colors(sjs);

bp = boxplot(norm_pos_IR,'labels', {'', '', ''},'colors', [0 0 0], 'Widths',0.1);
set(bp,'linewidth',2);
h=findobj(gca,'tag','Outliers');
set(h,'Visible', 'off') 
hold on
% errorbar(mean(norm_pos_SEQ,1), std(norm_pos_SEQ,0,1)./sqrt(size(norm_pos_SEQ,1)),'-', 'Color', [0.71 0.71 0.71], 'LineWidth', 4);

for s = 1 : sjs
     plot(jitters(s,1:2)+dist_, norm_pos_IR(s,1:2), 'o',  'Color', (colors(s,:)),'MarkerFaceColor', (colors(s,:)), 'MarkerSize',4,'LineWidth', 2)
     plot(jitters(s,1:2)+(1-dist_), norm_pos_IR(s,2:3), 'o',  'Color', (colors(s,:)),'MarkerFaceColor', (colors(s,:)), 'MarkerSize',4,'LineWidth', 2)
    
     plot([(jitters(s,1)+dist_) (jitters(s,1)+(1-dist_))], norm_pos_IR(s,1:2), '-','Color', (colors(s,:)), 'LineWidth', 1)
    plot([(jitters(s,2)+dist_) (jitters(s,2)+(1-dist_))], norm_pos_IR(s,2:3), '-','Color', (colors(s,:)), 'LineWidth', 1)
 
     hold on;
    xlim([0.5 3.5]);
    ylim([-0.9 0.9]);
end
plot(mean(norm_pos_IR,1), 'o','Color', [1 0 0], 'MarkerSize',8, 'MarkerFaceColor', [1 0 0])

% plot(mean(norm_pos_SEQ,1), 'gx','MarkerSize',8);

% title('recall position');


%% performance movies in CR (seq)
hits = [];
miss = [];
for s = 1 : sjs
    ret = squeeze(rets_seq{1,s});
    
    %real_movie == answer_movie & realposition == answer_position && conf>guess
    hit_trials = ret(cell2mat(ret(:,3))==cell2mat(ret(:,10))&cell2mat(ret(:,4))==cell2mat(ret(:,7)), :);
    
    %realmovie~=answermovie|realpos~=answerpos
    miss_trials = ret(cell2mat(ret(:,3))~=cell2mat(ret(:,10))|cell2mat(ret(:,4))~=cell2mat(ret(:,7)),:);
    
    for m = 1 : 12
        hits(s,m)= numel(find(cell2mat(hit_trials(:,1))==m));
    end
    for m = 1 : 12
        miss(s,m)= numel(find(cell2mat(miss_trials(:,1))==m));
    end
end

hits_perc = 100*hits./(hits+miss);
miss_perc = 100*miss./(hits+miss);
%all performance in condition
disp('mean and std');
all_prc_seq = 100* (sum(hits,2)./(sum(hits,2) + sum(miss,2)));
disp([100*mean(sum(hits,2)./(sum(hits,2) + sum(miss,2))) 100*std(sum(hits,2)./(sum(hits,2) + sum(miss,2)))])

% performance positions SEQ
pos1 = [1 4 7 10];
pos2 = pos1+1;
pos3 = pos1+2;

% addpath('C:\matlab_scripts\plotting')


hsqTOT = [sum(hits(:,pos1),2), ...
    sum(hits(:,pos2),2),...
    sum(hits(:,pos3),2)];
hspSEQ = [sum(hits(:,pos1),2)./(sum(hits(:,pos1),2)+sum(miss(:,pos1),2)), ...
    sum(hits(:,pos2),2)./(sum(hits(:,pos2),2)+sum(miss(:,pos2),2)),...
    sum(hits(:,pos3),2)./(sum(hits(:,pos3),2)+sum(miss(:,pos3),2))];
    
% figure;
% boxplot(100*hspSEQ,'labels', {'', '', ''},'colors', [0 0 0] )
% h=findobj(gca,'tag','Outliers');
% set(h,'Visible', 'off') 
% 
% 
% set(gcf, 'Position', get(0,'Screensize')); % Maximize figure. 
% % boxplot(hsp,'labels', {'Pos1', 'Pos2', 'Pos3'}, 'colors', [0 0 0] )
% hold on;
% errorbar(100*mean(hspSEQ,1), 100*std(hspSEQ,0,1)./sqrt(sjs),'-', 'Color', [0.71 0.71 0.71], 'LineWidth', 2)
% hold on;
% % colors = distinguishable_colors(sjs);
% jit_div = 5;
% tmpj = rand(24,3); tmpj =  bsxfun(@rdivide, bsxfun(@minus, tmpj,  mean(tmpj,1)), jit_div);
% jitters = repmat([1 2 3], [sjs,1]) + tmpj;
% for s = 1 : sjs
%     plot(jitters(s,:), 100*hspSEQ(s,:), 'o',  'Color',colors(s,:), 'MarkerSize',7,'MarkerFaceColor',colors(s,:))
%     hold on;
%     xlim([0 4])
%     ylim([0 100]);
% end

% set(gca, 'XTickLabel', { 'Pos1'  'Pos2' 'Pos3' })
% set(gcf,'Color', 'white');
% ylabel('percent correct')
% legend( ['mean', arrayfun(@(x) ['sj' num2str(x)],1:sjs,'UniformOutput',0)], 'Location', 'eastoutside'); legend('boxoff')
% title('performance in Sequence');
[h,p1, ci1, stats12] = ttest(hspSEQ(:,1),hspSEQ(:,2));
[h,p2, ci2, stats13] = ttest(hspSEQ(:,1),hspSEQ(:,3));
[h,p3, ci3, stats23] = ttest(hspSEQ(:,2),hspSEQ(:,3));
% clc
100*[ci1, ci2, ci3]
[efs,F,cdfs,p,eps,dfs,b,y2,sig] = repanova([hspSEQ ], [3], {'condition' 'position'});


%% performance movies in AR (ir = intact rearranged)

hits = [];
miss = [];
for s = 1 : sjs
    ret = squeeze(rets_ir{1,s});
    
    %hits are where the IR resonse is: INTACT and the "lure" was the
    %original AND not guessed
    hit_trials = ret(cell2mat(ret(:,7))==cell2mat(ret(:,10)));
%     hit_trials = ret(cell2mat(ret(:,7))==cell2mat(ret(:,10)));

    % miss trials are where rearranged was chosen wrongly (i.e. it was itact: 10 is 1 and didn't say intact) 
    miss_trials = ret(cell2mat(ret(:,7))~=cell2mat(ret(:,10))& cell2mat(ret(:,10))==1);
   
    % fa trials are where intact was chosen wrongly (i.e.10 is not intact but 7 was chosen as intact) 
    fa_trials = ret(1 ~=cell2mat(ret(:,10))& cell2mat(ret(:,7))==1);
    
    %the rest of rearranged ones...
    rr_rest= ret(1 ~=cell2mat(ret(:,10)) & 1 ~=cell2mat(ret(:,7)));
    
    for m = 1 : 12
        hits(s,m)= numel(find(cell2mat(hit_trials(:,1))==m));
    end
    for m = 1 : 12
        miss(s,m)= numel(find(cell2mat(miss_trials(:,1))==m));
    end
    for m = 1 : 12
        fa(s,m)= numel(find(cell2mat(fa_trials(:,1))==m));
    end
    for m = 1 : 12
        re(s,m)= numel(find(cell2mat(rr_rest(:,1))==m));
    end
end
%
hits_perc = 100*hits./(hits+miss);
fa_perc = 100*fa./(fa+re);
all_hits_perc = 100*sum(hits,2)./(sum(hits,2) + sum(miss,2));
all_prcfa = 100*sum(fa,2)./(sum(fa,2) + sum(re,2));
all_prc_hfa = all_hits_perc - 100*sum(fa,2)./(sum(fa,2) + sum(re,2));
disp('mean and std');
disp([mean(all_hits_perc) std(all_hits_perc)])

disp('mean and std FA');
disp([mean(all_prcfa) std(all_prcfa)])
% miss_perc = 100*miss./(hits+miss);
% boxplot(hits_perc,'labels', {'M1', 'M2', 'M3', 'M4', 'M5', 'M6', 'M7', 'M8', 'M9', 'M10', 'M11', 'M12'},'colors', [0 0 0] )
% hold
% plot(mean(hits_perc,1), 'o', 'Color', 'black')
% performance positions IR
pos1 = [1 4 7 10];
pos2 = pos1+1;
pos3 = pos1+2;


hspIR = [sum(hits(:,pos1),2)./(sum(hits(:,pos1),2)+sum(miss(:,pos1),2)), ...
    sum(hits(:,pos2),2)./(sum(hits(:,pos2),2)+sum(miss(:,pos2),2)),...
    sum(hits(:,pos3),2)./(sum(hits(:,pos3),2)+sum(miss(:,pos3),2))];

faIR = [sum(fa(:,pos1),2)./(sum(fa(:,pos1),2)+sum(re(:,pos1),2)), ...
    sum(fa(:,pos2),2)./(sum(fa(:,pos2),2)+sum(re(:,pos2),2)),...
    sum(fa(:,pos3),2)./(sum(fa(:,pos3),2)+sum(re(:,pos3),2))];
    
hfaIR = hspIR - faIR;
% figure;
% boxplot(hsp,'labels', {'Pos1', 'Pos2', 'Pos3'}, 'colors', [0 0 0] )
% hold on;
% errorbar(100*mean(hspIR,1), 100*std(hspIR,0,1),'-', 'Color', [0.71 0.71 0.71], 'LineWidth', 2)
% hold on;
% % colors = distinguishable_colors(sjs);
% for s = 1 : sjs
%     plot(100*(hspIR(s,:)-faIR(s,:)), 'x',  'Color',colors(s,:), 'MarkerSize',9,'LineWidth', 2)
%     hold on;
%     xlim([0 4])
%     ylim([30 100]);
% end
% 
% set(gca, 'XTickLabel', {'' 'Pos1', 'Pos2', 'Pos3' ''})
% set(gcf,'Color', 'white');
% ylabel('percent correct')
% legend( ['mean', arrayfun(@(x) ['sj' num2str(x)],1:sjs,'UniformOutput',0)], 'Location', 'eastoutside'); legend('boxoff')
% title('performance IR')
[h,p1, ci, stats] = ttest(hfaIR(:,1),hfaIR(:,2));
[h,p2, ci, stats] = ttest(hfaIR(:,1),hfaIR(:,3));
[h,p3, ci, stats] = ttest(hfaIR(:,2),hfaIR(:,3));
[p1, p2, p3]

%%

[efs,F,cdfs,p,eps,dfs,b,y2,sig] = repanova([hspSEQ ], [3], { 'positionSEQ'});
[efs,F,cdfs,p,eps,dfs,b,y2,sig] = repanova([hfaIR ], [3], { 'positionIR'});

[efs,F,cdfs,p,eps,dfs,b,y2,sig] = repanova([hspSEQ ,hfaIR], [2 3], {'condition' 'position'});

%post hoc

[h,pall, ci, stats] =  ttest(mean(hfaIR,2), mean(hspSEQ,2))
%% plot distributions of memory performance

plot([1 2], [mean(mean(hspSEQ, 2)), mean(mean(hfaIR, 2))], 'or'); hold on
plot([1.25 1.75], [mean(hspSEQ, 2), mean(hfaIR, 2)], 'o-'); 
hold on;
bp = boxplot([mean(hspSEQ, 2), mean(hfaIR, 2)], 'colors', [0 0 0], 'Widths',0.1);
set(bp,'linewidth',2);
h=findobj(gca,'tag','Outliers');
set(h,'Visible', 'off') 

xlim([0 3])
ylim([0 1])


